% calculates level of FOC, used in numerical solution (fzero)

function Z = FOC(P1, P2, c, wwa, ww, ll); % last 3 args - (W0, W, L)(i,j)

% global variables - see master file for comments
global beta % discount factor
global vOut sigma
global S

F = Fsale(P1, P2); % precalculate probailities
F0 = Fsale0(P1, P2);

% main calculation (factor of F/sigma dropped, and does not affect SOC)
%Z =  S .* sigma - (1-F) .* ( S.* (P1 - c) + beta .* ww ) + beta .* ( F0 .* wwa + (1 - F - F0) .* ll) ;  % scaling
Z =  sigma - (1-F) * ( P1 - c + beta .* ww ) + beta .* ( F0 .* wwa + (1 - F - F0) .* ll) ; 
