CCC	Adapting HOMPAC
CCC 	Routines dealing with files used for input/output
!!!	preprocessor directives (#...) try to pick system specific syntax
!!!	if you get errors from them
!!!	either enable preprocessor, or comment them out 
!!!      leaving one system-specific line of code
C -----------------------------------------------------------------------------------

	SUBROUTINE hom_InitializeStepfiles( startFileName)
#ifdef  COMPAQ_WIN
	USE DFLIB  ! for command line arguments
	USE DFPORT ! for command line arguments
#else 
#endif

	character* (*), INTENT(OUT)::startFileName
	character* 120  hom_MAINPATH
	COMMON/hom_general/hom_MAINPATH
	
!!!	if you get errors here, can comment out all but 
!!!	all but "hom_MAINPATH= '' "
!!!	and "write(... " lines

	if (iargc() .GT. 0) then
		CALL getarg(1,hom_MAINPATH)

#ifdef _WIN32
		write(hom_MAINPATH,'(A,A)') trim(hom_MAINPATH),'\'
#else
		write(hom_MAINPATH,'(A,A)') trim(hom_MAINPATH),'/'
#endif
	else
		hom_MAINPATH= ''
	endif
			
	write(startFileName,'(A,A)') trim(hom_MAINPATH),'hom_start.dat'
	
	END
C -----------------------------------------------------------------------------------


! Steve K.: end of save !!!!!!!!!!!!!!!!!!!!!
!  CALL hom_WriteStep(ITER, NP1, Y, S) 
! (_VF_VERSION_)     is not used by compaq preprocessor

! TO USE this:
! 1. change hompack add this as a subroutine to the HOMOTOPY module (in hompack90.f)
! 2. replace the "write step" statements in hompack90.f
! 3. run program with the directory name which has to exist and include hom_start.dat 
!    and HomXpt subdirectory
! 4. Change main to call hom_InitializeStepfiles( startFileName) (add interface)
! 4.5 in main, use the filename from hom_InitializeStepfiles( startFileName) to 
!     get the model parameters

C Save (X,lambda,s) to binary file
	SUBROUTINE hom_WriteStep(iter, NP1, Ywrite, Swrite,TRACE,NFE) 

      USE REAL_PRECISION, ONLY : R8
      
	INTEGER, INTENT(IN):: iter, NP1
	REAL (KIND=R8), INTENT(IN):: Ywrite(:)
	REAL (KIND=R8), INTENT(IN):: Swrite
	INTEGER, INTENT(IN)::TRACE
      INTEGER, INTENT(IN)::NFE
	character* 120  hom_MAINPATH
	COMMON/hom_general/hom_MAINPATH
      
	character*150 filenm ! SK: filename for saving step solutions
	integer ios, fid ! input-output status
	parameter (fid=13) ! file handle

CCC	Text output (1 line per step) to file and screen
C	this used to be in hompack90.f, in each fixp*() routine
      IF (TRACE .GT. 0) THEN
C Old text output line, commented out since it was outputting entire X
!        WRITE (TRACE,217) ITER,NFEC,S,Y(NP1),(Y(JW),JW=1,NC)
!217     FORMAT(/' STEP',I5,3X,'NFE =',I5,3X,'ARC LENGTH =',F9.4,3X,
!     &  'LAMBDA =',F7.4,5X,'X vector:'/(1X,6ES12.4))
C Steve K.: output one line per step, to screen
        WRITE (TRACE,218) iter, NFE,Swrite,Ywrite(NP1)
      ENDIF
      WRITE (*,218) iter, NFE,Swrite,Ywrite(NP1) 
218   FORMAT(' STEP',I5,3X,'NFE =',I5,3X,'ARC LENGTH =',F9.4,3X,
     &  'LAMBDA =',F7.4 )


CCC	Generate filename for current step, e.g."HomXpt\hom_00001.dat"
C     #ifdef is a preprocesser directive that uses correct slash 
C		on both Windows and Linux\Unix systems
C	User might need to activate preprocessor - read documentation on your compiler
C	preprocessor symbol "_WIN32" should be declared automatically
#ifdef _WIN32
	write(filenm,'(A,A,I5.5,A)') trim(hom_MAINPATH),'HomXpt\hom_',
     &		ITER,'.dat'
#else 
	write(filenm,'(A,A,I5.5,A)') trim(hom_MAINPATH),'HomXpt/hom_', 
     &		ITER,'.dat'
#endif

CCC	Open file
C	see comments on "#ifdef GFORTRAN" in *main.f file
#ifdef GFORTRAN
	open( UNIT=fid, FILE=filenm, STATUS="REPLACE",  
     & ACTION = "WRITE", IOSTAT = ios, ACCESS= "STREAM")
#else
	open( UNIT=fid, FILE=filenm, STATUS="REPLACE",  
     & ACTION = "WRITE", IOSTAT = ios, FORM = "BINARY")
#endif

CCC	
	if (ios>0) then
		print *, "file=",filenm," , ios=", float(ios)
		stop "Fortran: cannot create step file"
	end if
	write(fid) (Ywrite(JW),JW=1,NP1)
	write(fid) (Swrite)
	close(fid)
C	print *, "step file saved:",filenm
	END 
