      SUBROUTINE RHOJAC(A,LAMBDA,X,V,K)
      USE REAL_PRECISION, ONLY : R8
C      USE HOMPACK90_GLOBAL, ONLY: IPAR, PAR  ! for POLSYS1H only.
      USE HOMPACK90_GLOBAL
      REAL (KIND=R8), INTENT(IN):: A(:),X(:)
      REAL (KIND=R8), INTENT(IN OUT):: LAMBDA
      REAL (KIND=R8), INTENT(OUT):: V(:)
      INTEGER, INTENT(IN):: K
C
C Return in the vector  V  the Kth column of the Jacobian
C matrix [D RHO/D LAMBDA, D RHO/DX] evaluated at the point
C (A, LAMBDA, X).
C
C	variables for Adifor derivative calculation
	DOUBLE PRECISION Y(size(X)+1), DY(size(X)+1), DH(size(X)), 
     &			H(size(X))
C
C	other variables
      INTEGER:: N, NP1 ! size of X
      INTEGER:: I, IK, QPOS, RPOS ! various array indeces
C
      INTERFACE
      subroutine g_rho1(n, x, g_x, h, g_h)
        integer n
        double precision x(n + 1), h(n)
        double precision g_x(n + 1), g_h(n)
      end subroutine g_rho1
	END INTERFACE
C
C	initialize and reset
	N = size(X)
	NP1=N+1
	DH = 0.0
	DY = 0.0
	H = 0.0
C
	Y(1:N)=X(1:N)
	Y(N+1)=LAMBDA
C
C	compute dH/dY(K)
	if(K.eq.1)then
		DY(N+1)=1.0
	else
		DY(K-1)=1.0
	end if


	call g_rho1(n, y, dy, h, dh)

	V=DH
c	write(*,'(A,I5,A,e10.1)') '   RHOJAC started,N=',N,
c     &            ', lbd=',LAMBDA,', K=',K
C
      RETURN
      END
