% create and init. global vars (params, results) - Entry and exit

% if notation is different from paper, original is given in brackets

%%%%%% General
global M % max level of efficiency
if isempty(M) | M==0
    M = 20; % default value, used if not specified in master*.m
    disp(sprintf( 'Using default value of M=%d', M ))
end
global drate beta % discount rate and factor
    drate=0.05; beta=1/(1+drate); % set drate=inf for beta=0

%%% Cost as function of efficiency cost.m(efficiency)
global kappa rho eta % coefs
    kappa = 10; rho = 0.85; eta = log(rho)/log(2);
    
global mmax; % max meaningfull level of efficiency (paper: m)
    mmax = 15; 

%%% Contional transition probability transLC(i,old_i,outcome)
global delta1 delta2 lambda % efficiency depreciation
%%%%%%%%%%%%%%%%%%%%%%%%%% DEPRECIATION
    delta1 = 0.1; % constant depreciation, values 0.1 0.2 0.3 0.4
    delta2 = 0.1; % proportional depreciation, values 0.1 0.2
    lambda = 0; % type mixing: 0 - proportional, 1 - constant

global win loose % conditioning events (outcomes of sale)
    win = 1; loose = 0; % just constants to visualize formulas
%%%% do not change these values they are replicated in 

%%% Probability of Sale, as function of prices : Fsale.m(p1,p2)
global vOut sigma % old v0 and differentiation factor
global v_alt c_alt v_gd % new: utility of alt, cost(=price) of alternative, utility of good
   % paper notation: v0, c0, v -- the change is to avoid confusion with V, V0 (value f-ns)
    c_alt = 10; v_alt = c_alt; v_gd = v_alt;
    vOut = v_alt - v_gd - c_alt; %%% "old v0", cost of alternative
    sigma = 1;

%%% scrap & value & entry cost distribution
global X a S b %epsilon 
    X = 3;  a = 3; %epsilon = a; % phase out epsilon
    S = 6; b = 3;
global XC SS % Exit Cushion and Set-up Subsidy
   XC = 0; SS = 0;    

%%% Predation constraint
global BanPred NonNegP MonCap
    BanPred = 0; % 0 - NOT BAN predation, 1 (or >0) BAN
    NonNegP = 0; % 1 to enforce non-negative prices, 0 otherwise
    MonCap = []; % if set, caps price of monopolist

%%% Iteration control
global tol maxiter dampP dampS dampS2 steps rateP rateD 
    tol = 0.0001; % tolerance, end of iteration (should be 1e-4 )
    maxiter = 750; % maximum iterations
    dampP = 1; % dampening for policy updating (1=full effect)
    dampS = 1; % dampening for prob. of staying
    steps = 1; % updates of value function
    rateP = 0; % refresh rate for iteration plot, 0 for no plot
    rateD = 3; % display rate
global iter done % outputs
global Convd % '' if converged, 'Iter, tolV, tolp' if not
    Convd='';
   
    
%%%%%%%%% Create matrices to hold value, policy, expectation functions

global V p W L Wa stay U% W0 - condtioning on alternative winning

Wa = zeros(M+1,M+1); % expected value of Loosing to Alternative
W = zeros(M+1,M+1); % expected value of Winning the sale
L = zeros(M+1,M+1); % expected value of Loosing to other firm
U = zeros(M+1,M+1); % value of staying

% outputs
p = zeros(M+1,M+1); % policy functions 
V = zeros(M+1,M+1); % value functions
stay = zeros(M+1,M+1); % prob. of staying in the industry


global dp marga % diff in prices and absolute margin
global ProbC Profit Profits % conditional prob. of winning, 
  % expected profit of single firms and both firms
global maxdP

global DL T DT %limiting distribution
T = [5,25,50,75];  % periods for transient distribution
% DT = zeros(M+1,M+1,length(T)); %store of transient distrbutions
global limT % time period for direct calculation of limiting distribution
   limT=0; % default value, 2b re-set either in master.m or markEE_limDirect.m
   
% symmetry
global lMode lMean % mode and mean (expectation) of "firm-size" distribution
global lAngl lAngl2 lHerfP lHerfP0 lHerfV
global maxHerfP amaxHerfP % maximum 

global IDfail IIDfail IIIDtext % number of failures + text
global IDfp IIDfp % probability of failure
global lWelfare lSurplus lWelfareD lSurplusD 
    % expected welfare, total surplus, plus discounted (PV)
global lDyears % number of years used to calc discounted surplus

global lRevers % reversal - exp. time to reversal to diagonal
global lLeadP lFlwP lExpP % leader, follower, expected prices

global P Pe % transition matrices: P - conditional on duopoly (M,M)
            %Pe - allows for exit (M+1, M+1)
    P=[]; Pe=[];
    
global i0 j0 maxT state0 
  maxT = 100; % number length of time path
  i0 = M+1;		% {0} initial state of firm 1.
  j0 = M+1;		% {0} initial state of firm 2.
  state0 = '(0,0)'; % intial state as string

% NE  parameterization  
delta1=0.1; lambda = 0; % (Proportional depreciation w/ alternative)
BanPred = 0; % ban on predation (below-cost pricing)
NonNegP = 0; % 1 to enforce non-negative prices, {0} otherwise
a = 1; X = -10; b = a; S = -5; % basic no entry setup
vOut = -100; % alternative good: vOut=v0-c0-v (v=10 by default)
            %vOut=-100 means no outside good

    
