% transition matrix for duopoly with exit & entry



global P Pe % transition matices
global p
global win loose % conditioning events (outcomes of sale)

if win == loose
        win = 1; loose = 0; % just constants to visualize formulas
end

global delta
delta=zeros(M,1);
for i=1:M
        delta(i) = 1 - (1-delta2).^i;
end


disp('Calculating transition matrix (E&E)...');
tic;

Pe = zeros((M+1).^2,(M+1).^2); % global transitions (with ee)
P = zeros(M.^2,M.^2); % conditional transitions, within duopoly
% from (i,j) to (k,n) at ( (i-1).*(M+1)+j, (k-1).*(M+1)+n )

for i=1:(M+1)
   for j=(1:M+1)
       % Code sections for transtions btw. macro-states :
       %%%%%%%%%%
       %         from \ to      duo   mon(i)   mon(j)  empty
       % i<M+1,j<M+1:    duo    <1>    <5>      <2>     <9>
       % i<M+1,j=M+1: mon(i)    <4>    <5>      <3>     <9>
       % i=M+1,j<M+1: mon(j)    <7>    <6>      <2>     <9>
       % i=M+1,j=M+1:  empty    <8>    <6>      <3>     <9>
      
      if i<=M & j<=M % <<< 1 >>> duo to duo
          F1 = Fsale( p(i,j), p(j,i) );  % precalculate probabilities
          F0 = Fsale0( p(i,j), p(j,i) );
      
          for k=max(1,i-1):min(i+1,M) % consider only attainable states (i/j +/- 1, )
          for n=max(1,j-1):min(j+1,M)
                P((i-1).*M+j, (k-1).*M+n) = ... % save conditional transition matrix
                               F0 .* transE(k,i,loose) .* transE(n,j,loose) ... 
                             + F1 .* transE(k,i,win) .* transE(n,j,loose) ...
                 + ( 1 - F1 -F0 ) .* transE(k,i,loose) .* transE(n,j,win); 
             
                Pe( (i-1).*(M+1)+j, (k-1).*(M+1)+n ) =  stay(i,j) * stay(j,i) ...
                                            * P((i-1).*M+j, (k-1).*M+n);   
          end % for n
          end % for k
          
      end % if i<=M & j<=M
      
      if j<=M % <<< 2 >>>  { duo & mon(j) } to mon(j)
          k=M+1;
          F1 = Fsale ( p(M+1,j), p(j,M+1) );  % precalculate probabilities
          F0 = Fsale0( p(M+1,j), p(j,M+1) );
          if round(F1*1000000)>0 % check
              error('F1>0 while i=M+1')
          end

          for n = max(1,j-1):min(j+1,M)
              Pe( (i-1).*(M+1)+j, (k-1).*(M+1)+n ) =  (1 - stay(i,j)) * stay(j,i) * ( ... 
                               F0 .* transE(n,j,loose) ...
                     + ( 1 - F0 ) .* transE(n,j,win) );   
          end % for n
      else % i.e. j==M+1 -- from {mon(i), empty} 
          
          % <<< 3 >>>  from {mon(i), empty} to mon(j)
          k=M+1;
          F1 = Fsale( p(M+1,1), p(1,M+1) );  % precalculate probabilities
          F0 = Fsale0( p(M+1,1), p(1,M+1) );
          if round(F1*1000000)>0 % check
              error('F1>0 while i=M+1')
          end
          
          for n=1:2 % j enters at top of curve
              Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) = ( 1 - stay(i,j) ) * stay(j,i) * (... % save conditional transition matrix
                               F0 .*  transE(n,1,loose) ... 
                 + ( 1 - F1 -F0 )  .* transE(n,1,win) ); 
          end % n
          
          if i < M+1 % <<< 4 >>>  mon(i) to duo 
              F1 = Fsale( p(i,1), p(1,i) );  % precalculate probabilities
              F0 = Fsale0( p(i,1), p(1,i) );
              
              for k=max(1,i-1):min(i+1,M) % consider only attainable states (i +/- 1 )
              for n=1:2 % j enters at top of curve
                  Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) = stay(i,j) * stay(j,i) * (... % save conditional transition matrix
                               F0 .* transE(k,i,loose) .* transE(n,1,loose) ... 
                             + F1 .* transE(k,i,win  ) .* transE(n,1,loose) ...
                 + ( 1 - F1 -F0 ) .* transE(k,i,loose) .* transE(n,1,win) ); 
              end % n
              end % k
          end % if i < M+1
          
      end %if j<=M
      
      if i<=M  % <<< 5 >>> { duo, mon(i) } to mon(i)
          n=M+1;
          F1 = Fsale( p(i,M+1), p(M+1,i) );  % precalculate probabilities
          F0 = Fsale0( p(i,M+1), p(M+1,i) );
          if round((F1+F0-1)*1000000)>0 % check
              error('F1+F0 < 1 when j=M+1')
          end
      
          for k=max(1,i-1):min(i+1,M) % consider only attainable states (i/j +/- 1, )
                Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) =  stay(i,j) * ( 1 - stay(j,i) ) * ( ... 
                               F0 .* transE(k,i,loose)  ...
                             + F1 .* transE(k,i,win)  ...
                 + ( 1 - F1 -F0 ) .* transE(k,i,loose) );   
          end % for k
          
      else % i==M+1, i.e. from {mon(j), empty}
          % <<< 6 >>> from {mon(j), empty} to mon(i)
          n=M+1;
          F1 = Fsale ( p(1,M+1), p(M+1,1) );  % precalculate probabilities
          F0 = Fsale0( p(1,M+1), p(M+1,1) );
          if round((F1+F0-1)*1000000)>0 % check
              error('F1+F0 < 1 when j=M+1')
          end
      
          for k=1:2 
                Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) = stay(i,j) * (1 - stay(j,i)) * (... % save conditional transition matrix
                               F0 .* transE(k,1,loose)  ... 
                             + F1 .* transE(k,1,win  ) ); 
          end % for k
          
          if j<M+1  % <<< 7 >>> from mon(j) to duo
              F1 = Fsale ( p(1,j), p(j,1) );  % precalculate probabilities
              F0 = Fsale0( p(1,j), p(j,1) );
      
              for k=1:2 
              for n=max(1,j-1):min(j+1,M) 
                  Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) = stay(i,j) * stay(j,i) * (... % save conditional transition matrix
                               F0 .* transE(k,1,loose) .* transE(n,j,loose) ... 
                             + F1 .* transE(k,1,win  ) .* transE(n,j,loose) ...
                 + ( 1 - F1 -F0 ) .* transE(k,1,loose) .* transE(n,j,win) ); 
              end % for n
              end % for k
          end % if j<M+1
          
      end % if i<=M
      
      if (i == M+1) & (j == M+1) % <<< 8 >>> from empty to duo
          F1 = Fsale( p(1,1), p(1,1) );  % precalculate probabilities
          F0 = Fsale0( p(1,1), p(1,1) );
      
          for k=1:2 % consider only attainable states (i/j +/- 1, )
          for n=1:2
                Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n) = stay(i,j) * stay(j,i) * (... % save conditional transition matrix
                               F0 .* transE(k,1,loose) .* transE(n,1,loose) ... 
                             + F1 .* transE(k,1,win) .* transE(n,1,loose) ...
                 + ( 1 - F1 -F0 ) .* transE(k,1,loose) .* transE(n,1,win) ); 
          end % for n
          end % for k
          
      end
      
      % <<< 9 >>> from any to empty 
      k=M+1; n=M+1;
      Pe( (i-1).*(M+1) + j, (k-1).*(M+1) + n ) =  ( 1 - stay(i,j) ) * ( 1 - stay(j,i) );
      
   end % for j
end % for i

P = sparse(P); % compactify transition matrix
Pe = sparse(Pe);

if (round(10000*max(sum(Pe,2)))~=10000) | (round(min(sum(Pe,2))*10000)~=10000)
    error('Transition matrix row(s) do not add up to 1.0')
end

disp(sprintf('   ... Done (time elapsed - %f)',toc))

clear F F0 i j k n;
