% WL.m - Calculates expected value of win (W) and Loss L
% duopoly, no entry/exit, Alternative good
% condtitioning on state (i,j)
%     No L is necessary as W(i,j)=L(j,i)

% global variables - see master file for comments
global V W L Wa
global win loose % conditioning events (outcomes of sale)
global M % max level of efficiency

P1 = zeros(1,2); % prob of possible i
P2 = zeros(2,1); % probs of possible j
V2 = zeros(2,2); % holds values for possible states (i,j) 

for i=1:M
    for j=1:M
        %%% Wa (Alternative wins)
        % calculate probabilities
        P1(1) = transLC(i  ,i,loose);
        P1(2) = transLC(i-1,i,loose);
        P2(1) = transLC(j  ,j,loose);
        P2(2) = transLC(j-1,j,loose);
        
        % calculate values (check for boundary)
        V2(1,1) = V(i,j);
        
        if i > 1
            V2(2,1) = V(i-1,j);
        else % i = M, i+1 is out of range
             V2(2,:) = zeros(1,2);
        end
     
        if j > 1 
             V2(1,2) = V(i,j-1);
        else % j = 1, j-1 is out of range
            V2(:,2) = zeros(2,1);
        end
        
        if i > 1 & j > 1
            V2(2,2) = V(i-1,j-1);
        end % else is take care of above
        
        % main calculation
        Wa(i,j) = P1*V2*P2; 
        
        
        %%% W (WIN)
        % calculate probabilities
        P1 = zeros(1,2); 
        P2 = zeros(2,1); 
        V2 = zeros(2,2); 
        P1(1) = transLC(i+1,i,win);
        P1(2) = transLC(i  ,i,win);
        P2(1) = transLC(j  ,j,loose);
        P2(2) = transLC(j-1,j,loose);
        
        % calculate values (check for boundary)
        V2(2,1) = V(i,j);
        
        if i < M
            V2(1,1) = V(i+1,j);
        else % i = M, i+1 is out of range
             V2(1,:) = zeros(1,2);
        end
     
        if j > 1 
             V2(2,2) = V(i,j-1);
        else % j = 1, j-1 is out of range
            V2(:,2) = zeros(2,1);
        end
        
        if i < M & j > 1
            V2(1,2) = V(i+1,j-1);
        end % else is take care of above
        
        % main calculation
        W(i,j) = P1*V2*P2; 
        
        %%% L (LOOSE)
        % calculate probabilities
        P1 = zeros(1,2); 
        P2 = zeros(2,1); 
        V2 = zeros(2,2); 
        
        P1(1) = transLC(i  ,i,loose);
        P1(2) = transLC(i-1,i,loose);
        P2(1) = transLC(j+1,j,win);
        P2(2) = transLC(j  ,j,win);
        
        V2(1,2)=V(i,j);
        
        if j < M
            V2(1,1) = V(i,j+1);
        else % i = M, i+1 is out of range
             V2(:,1) = zeros(2,1);
        end
     
        if i > 1 
             V2(2,2) = V(i-1,j);
        else % j = 1, j-1 is out of range
            V2(2,:)=zeros(1,2);
        end
        
        if i > 1 & j < M
            V2(2,1) = V(i-1,j+1);
        end % else is take care of above
        
        %main calc
        L(i,j) = P1*V2*P2; 

    end %i
end %j


% alternative sol - add row and column of zeros to V