C                           DISCLAIMER
C
C   This file was generated on  by the version of
C   ADIFOR compiled on June, 1998.
C
C   ADIFOR was prepared as an account of work sponsored by an
C   agency of the United States Government, Rice University, and
C   the University of Chicago.  NEITHER THE AUTHOR(S), THE UNITED
C   STATES GOVERNMENT NOR ANY AGENCY THEREOF, NOR RICE UNIVERSITY,
C   NOR THE UNIVERSITY OF CHICAGO, INCLUDING ANY OF THEIR EMPLOYEES
C   OR OFFICERS, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY, COMPLETE-
C   NESS, OR USEFULNESS OF ANY INFORMATION OR PROCESS DISCLOSED, OR
C   REPRESENTS THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
      subroutine g_rho1(n, x, g_x, h, g_h)
!     subroutine g_rho1(n, x, g_x, h, g_h) !<<< copied from ITERFACE in rhojs.f
C     SUBROUTINE RHO(A,LAMBDA,X,H)
C
C   EVALUATE  RHO(A,LAMBDA,X)  AND RETURN IN THE VECTOR  H .
C     MODEL: learning and forgetting, entry and exit
C
C     IMPLICIT NONE
C      USE REAL_PRECISION, ONLY : R8
C      REAL (KIND=R8), INTENT(IN):: A(:),X(:)
C      REAL (KIND=R8), INTENT(IN OUT):: LAMBDA
C      REAL (KIND=R8), INTENT(OUT):: H(:)
C           INTEGER:: N
C
        integer n
        real*8 x(n + 1)
        real*8 h(n)
C
C
C
C     model parameters *********
!        parameter (m0 = 30) ! was only use to get through ADIFOR's syntax check
        integer m, mmax
        real*8 vout, sigma
        real*8 delta_beg, delta_end
        real*8 beta
        common /modelparams/ beta, vout, sigma, delta_beg, delta_end, m,
     * mmax
        real*8 delta, deltavec(m)
C     cost parameters and vector
        real*8 rho_beg, rho_end, kappa
        common /costparams/ rho_beg, rho_end, kappa
        real*8 cost(m), eta
C
C offsets in X and H vectors
        integer offp, offv
        integer offbell, offfoc
        common /offsets/ offp, offv, offbell, offfoc
C
C     service variables
        integer i, j, k
        real*8 tempm(5)
C     conditional expectation, exponents and probabilities
        real*8 w(0:2), exps(0:2), d(0:2)
C other usefull stuff
        real*8 pij, demon
C
C     Functions
        real*8 transprob
C     CalcW is a routine
C
C      N=SIZE(X)
C
C preliminary calculations
C current delta & depr. probability vector 
! SK: changed "double precision" to "real*8" - it did not like var(m) declarations
        double precision d1
        double precision g_getv, d1_w, d6_v, d2_v, d3_v, d8_v, d1_p, g_d
     *elta, g_x(n + 1), g_deltavec(m)
        double precision g_d1_w, g_eta, g_cost(m), g_exps(0:2), g_pij, 
     *g_demon, g_d(0:2), g_h(n), g_w(0:2), g_d1
        integer g_ehfid
        save g_d1
        save g_delta, g_d1_w, g_eta, g_exps, g_pij, 
     *g_demon, g_d, g_w
!		, g_deltavec, g_cost
        external g_getv
        external g_calcw
        intrinsic dble
        data g_ehfid /0/
C
!        call ehsfid(g_ehfid, 'rho1','g_NE_rho1.f')
C
        g_delta = (delta_end - delta_beg) * g_x(n + 1)
        delta = delta_beg + x(n + 1) * (delta_end - delta_beg)
C--------
        do 99999 i = 1, m

          if (  i .ne. 0 ) then
             d3_v = (1.0d0 - delta) ** ( i-1)
             d1_p =  i *  d3_v
             d3_v =  d3_v * (1.0d0 - delta)
          else
C            Maybe this should be  d3_v = (1.0d0 - delta) **  i
             d3_v = 1.0d0
             d1_p = 0.0d0
          endif
          g_deltavec(i) = d1_p * g_delta
          deltavec(i) = 1.0d0 - d3_v
C--------
10        continue
99999   continue
C
C     cost vector
        g_d1_w = (rho_end - rho_beg) * g_x(n + 1)
        d1_w = rho_beg + x(n + 1) * (rho_end - rho_beg)
        d2_v = log(d1_w)
        d1_p = 1.0d0 / d1_w
        g_eta = 1.0d0 / dlog(2.0d0) * d1_p * g_d1_w
        eta = d2_v / dlog(2.0d0)
C--------
        do 99998 i = 1, m
          d2_v = dble(min0(i, mmax)) **  eta
          if ( dble(min0(i, mmax)) .gt. 0.0d0 ) then
             
C            Use  d1_p to store `log(dble(min0(i, mmax)))'
             d1_p = log (dble(min0(i, mmax)))

             d1_p =  d1_p *  d2_v
          else
C            ( dble(min0(i, mmax)) <= 0 )

             
             if ( (dble(min0(i, mmax)) .eq. 0.0d0) .and. ( eta .ne. 0.0d
     +0) ) then
                d1_p = 0.0d0
             else
!                call ehbfDO (11,dble(min0(i, mmax)), eta, d2_v, 0.0d0, d
!     +1_p,
!     +g_ehfid,
!     +133)
             endif

          endif
          g_cost(i) = kappa * d1_p * g_eta
          cost(i) = kappa * d2_v
C--------
20        continue
99998   continue
C
C exponent for alternative
        if (vout .gt. (-101.0)) then
          g_exps(0) = 0.0d0
          exps(0) = dexp(vout / sigma)
C--------
        else
          g_exps(0) = 0.0d0
          exps(0) = 0.0d0
C--------
C      print *, 'resetting outside good to -inf'
        endif
C     
C     HOMOTOPY EQUATIONS - quick plug
C      do 110 i=1,M*M*2
C         H(i)=0
C 110     continue
C
C     state space loop (single continue) *******************
        do 99995 i = 1, m
          do 99996 j = 1, m
C
C       get prices, exponents and win probabilities
            g_pij = g_x(offp + i + (j - 1) * m)
            pij = x(offp + i + (j - 1) * m)
C--------
            g_d1_w = (-(1.0d0 / sigma)) * g_pij
            d1_w = (-pij) / sigma
            d2_v = exp(d1_w)
            d1_p =  d2_v
            g_exps(1) = d1_p * g_d1_w
            exps(1) = d2_v
C--------
            g_d1_w = (-(1.0d0 / sigma)) * g_x(offp + j + (i - 1) * m)
            d1_w = (-x(offp + j + (i - 1) * m)) / sigma
            d2_v = exp(d1_w)
            d1_p =  d2_v
            g_exps(2) = d1_p * g_d1_w
            exps(2) = d2_v
C--------
            g_demon = g_exps(2) + g_exps(1) + g_exps(0)
            demon = exps(0) + exps(1) + exps(2)
C--------
C
            do 99997 k = 0, 2
              d3_v = exps(k) / demon
              g_d(k) = (-d3_v) / demon * g_demon + 1.0d0 / demon * g_exp
     *s(k)
              d(k) = d3_v
C--------
40            continue
99997       continue
C
C     get conditional expectations
            call g_calcw(i, j, w, g_w, x, g_x, m, deltavec, g_deltavec)
C
C     price equation (FOC*sigma/F1)
            d2_v = 1.0d0 - d(1)
            d8_v = pij - cost(i) + beta * w(1)
            g_h(offfoc + i + (j - 1) * m) = beta * d(2) * g_w(2) + beta 
     ** w(2) * g_d(2) + beta * d(0) * g_w(0) + beta * w(0) * g_d(0) + (-
     *d2_v) * beta * g_w(1) + d2_v * g_cost(i) + (-d2_v) * g_pij + d8_v 
     ** g_d(1)
            h(offfoc + i + (j - 1) * m) = sigma - d2_v * d8_v + beta * (
     *d(0) * w(0) + d(2) * w(2))
C--------
C     value equation (Bellman)
            d1 = g_getv(i, j, x, g_x, m, g_d1)
            d6_v = pij - cost(i)
            g_h(offbell + i + (j - 1) * m) = beta * d(2) * g_w(2) + beta
     * * w(2) * g_d(2) + beta * d(1) * g_w(1) + beta * d(0) * g_w(0) + b
     *eta * w(0) * g_d(0) + (-d(1)) * g_cost(i) + d(1) * g_pij + (beta *
     * w(1) + d6_v) * g_d(1) + (-g_d1)
            h(offbell + i + (j - 1) * m) = -d1 + d(1) * d6_v + beta * (d
     *(0) * w(0) + d(1) * w(1) + d(2) * w(2))
C--------
C
30          continue
99996     continue
31        continue
99995   continue
C
C     Test stuff **********************
C         print *, 'Trans prob to (i-1,i,i+1,sum) for loose'
C      print *, 'Depr. probs(delta=',delta,'):'
C      print *,'cost vector'
C      print *, 'V(1:5,1:5)='
C
C      do 120 i=1,5
C         tempM(1)=TransProb(i-1,i,0,deltaVec,M)
C         tempM(2)=TransProb(i  ,i,0,deltaVec,M)
C         tempM(3)=TransProb(i+1,i,0,deltaVec,M)
C         tempM(4)=tempM(1)+tempM(2)+tempM(3)
C         print *, float(i), (tempM(j),j=1,4) 
C
C         print *, float(i), deltaVec(i)
C         print *, float(i), cost(i)
C
C         do 130 j=1,5
C            tempM(j)=GetV(i,j,X,M)         
C 130     continue
C         print *, (tempM(j),j=1,5),GetV(i,0,X,M) 
C
C 120   continue
C
C test of conditional expectation
C$$$      call CalcW(1,1,W,X,M,deltaVec)
C$$$      print *, 'W for (1,1): ', (W(j),j=0,2)
C$$$      call CalcW(4,5,W,X,M,deltaVec)
C$$$      print *, 'W for (4,5): ', (W(j),j=0,2)
C$$$      call CalcW(6,1,W,X,M,deltaVec)
C$$$      print *, 'W for (6,1): ', (W(j),j=0,2)
C$$$      call CalcW(2,20,W,X,M,deltaVec)
C$$$      print *, 'W for (2,20): ', (W(j),j=0,2)
C
      end
C
C service functions *****************************
C
C     Transtion probabilities function ****************************
      function g_transprob(i, old_i, outcome, deltavec, g_deltavec, m, g
     *_dres_)
        integer i, old_i, outcome, m
        real*8 deltavec(m), di
C
        double precision g_transprob, g_dres_, g_di, g_deltavec(m)
        integer g_ehfid
        save g_di
        intrinsic dble
        data g_ehfid /0/
C
!        call ehsfid(g_ehfid, 'transprob','g_NE_rho1.f')
C
        g_di = g_deltavec(old_i)
        di = deltavec(old_i)
C--------
C
        if (outcome .eq. 1) then
C      win
          if (old_i .lt. m) then
C        middle of state space
            if (i .eq. old_i + 1) then
              g_dres_ = -g_di
              g_transprob = 1.0d0 - di
C--------
            else
              if (i .eq. old_i) then
                g_dres_ = g_di
                g_transprob = di
C--------
              else
                g_dres_ = 0.0d0
                g_transprob = 0.0d0
C--------
              endif
            endif
C
          else
C         old_i==M
            if (i .eq. old_i) then
              g_dres_ = 0.0d0
              g_transprob = 1.0d0
C--------
            else
              g_dres_ = 0.0d0
              g_transprob = 0.0d0
C--------
            endif
C
          endif
C
        else
C       loose
          if (old_i .gt. 1) then
C        interior of state space
            if (i .eq. old_i) then
              g_dres_ = -g_di
              g_transprob = 1.0d0 - di
C--------
            else
              if (i .eq. old_i - 1) then
                g_dres_ = g_di
                g_transprob = di
C--------
              else
                g_dres_ = 0.0d0
                g_transprob = 0.0d0
C--------
              endif
            endif
C
          else
C        edge of state space
            if (i .eq. old_i) then
              g_dres_ = 0.0d0
              g_transprob = 1.0d0
C--------
            else
              g_dres_ = 0.0d0
              g_transprob = 0.0d0
C--------
            endif
C
          endif
C
        endif
C
      end
C
C Get Value function from x-vector *******************************
      function g_getv(i, j, x, g_x, m, g_dres_)
        integer i, j, m
        double precision x(2 * m * m)
C
C offsets in X and H vectors
        integer offp, offv
        integer offbell, offfoc
        common /offsets/ offp, offv, offbell, offfoc
C
        double precision g_getv, g_dres_, g_x(2 * m * m)
        integer g_ehfid
        intrinsic dble
        data g_ehfid /0/
C
!        call ehsfid(g_ehfid, 'getv','g_NE_rho1.f')
C
        if ((i .ge. 1) .and. (i .le. m) .and. (j .ge. 1) .and. (j .le. m
     *)) then
          g_dres_ = g_x(offv + i + (j - 1) * m)
          g_getv = x(offv + i + (j - 1) * m)
C--------
        else
          g_dres_ = 0.0d0
          g_getv = 0.0d0
C--------
        endif
C
      end
C
C Conditional expectations function *****************
C     W - receives the vector
      subroutine g_calcw(i, j, w, g_w, x, g_x, m, deltavec, g_deltavec)
        integer i, j, m
        double precision x(2 * m * m)
        real*8 deltavec(m)
        real*8 w(0:2)
C
C     probablities if loosing
        real*8 p1(0:1), p2(0:1)
C     conditioning constants
C
C     functions
C      real*8 TransProb(i, old_i, outcome, deltaVec, M)
C      real*8 GetV(i,j,X,M)
C
C      precalculate probabilites conditional on loosing
        double precision d1, d2, d3, d4, d5, d6, d7, d8
        double precision g_getv, g_transprob, d13_v, d8_v, d17_v, d3_v, 
     *d18_v, d19_v, d12_v, g_w(0:2)
        double precision g_d1, g_p1(0:1), g_p2(0:1), g_d2, g_d3, g_d4, g
     *_d5, g_d6, g_d7, g_d8
        double precision g_x(2 * m * m), g_deltavec(m)
        integer g_ehfid
        save g_d1, g_p1, g_p2, g_d2, g_d3, g_d4, g_d5, g_d6, g_d7, g_d8
        external g_getv
        external g_transprob
        data g_ehfid /0/
C
!        call ehsfid(g_ehfid, 'calcw','g_NE_rho1.f')
C
        p1(0) = g_transprob(i - 1, i, 0, deltavec, g_deltavec, m, g_p1(0
     *))
        p1(1) = g_transprob(i, i, 0, deltavec, g_deltavec, m, g_p1(1))
        p2(0) = g_transprob(j - 1, j, 0, deltavec, g_deltavec, m, g_p2(0
     *))
        p2(1) = g_transprob(j, j, 0, deltavec, g_deltavec, m, g_p2(1))
C
C       main calculation
        d1 = g_getv(i, j, x, g_x, m, g_d1)
        d2 = g_getv(i - 1, j, x, g_x, m, g_d2)
        d3 = g_getv(i, j - 1, x, g_x, m, g_d3)
        d4 = g_getv(i - 1, j - 1, x, g_x, m, g_d4)
        d3_v = d1 * p1(1)
        d8_v = d2 * p1(0)
        d12_v = d3 * p1(1)
        d17_v = d4 * p1(0)
        g_w(0) = p2(0) * p1(0) * g_d4 + (d17_v + d12_v) * g_p2(0) + p2(0
     *) * p1(1) * g_d3 + (p2(0) * d4 + p2(1) * d2) * g_p1(0) + p2(1) * p
     *1(0) * g_d2 + (d8_v + d3_v) * g_p2(1) + (p2(0) * d3 + p2(1) * d1) 
     ** g_p1(1) + p2(1) * p1(1) * g_d1
        w(0) = d3_v * p2(1) + d8_v * p2(1) + d12_v * p2(0) + d17_v * p2(
     *0)
C--------
C
        d1 = g_getv(i, j, x, g_x, m, g_d1)
        d2 = g_transprob(i, i, 1, deltavec, g_deltavec, m, g_d2)
        d3 = g_getv(i + 1, j, x, g_x, m, g_d3)
        d4 = g_transprob(i + 1, i, 1, deltavec, g_deltavec, m, g_d4)
        d5 = g_getv(i, j - 1, x, g_x, m, g_d5)
        d6 = g_transprob(i, i, 1, deltavec, g_deltavec, m, g_d6)
        d7 = g_getv(i + 1, j - 1, x, g_x, m, g_d7)
        d8 = g_transprob(i + 1, i, 1, deltavec, g_deltavec, m, g_d8)
        d3_v = d1 * d2
        d8_v = d3 * d4
        d13_v = d5 * d6
        d19_v = d7 * d8
        g_w(1) = p2(0) * d7 * g_d8 + p2(0) * d8 * g_d7 + (d19_v + d13_v)
     * * g_p2(0) + p2(0) * d5 * g_d6 + p2(0) * d6 * g_d5 + p2(1) * d3 * 
     *g_d4 + p2(1) * d4 * g_d3 + (d8_v + d3_v) * g_p2(1) + p2(1) * d1 * 
     *g_d2 + p2(1) * d2 * g_d1
        w(1) = d3_v * p2(1) + d8_v * p2(1) + d13_v * p2(0) + d19_v * p2(
     *0)
C--------
C
        d1 = g_getv(i, j, x, g_x, m, g_d1)
        d2 = g_transprob(j, j, 1, deltavec, g_deltavec, m, g_d2)
        d3 = g_getv(i - 1, j, x, g_x, m, g_d3)
        d4 = g_transprob(j, j, 1, deltavec, g_deltavec, m, g_d4)
        d5 = g_getv(i, j + 1, x, g_x, m, g_d5)
        d6 = g_transprob(j + 1, j, 1, deltavec, g_deltavec, m, g_d6)
        d7 = g_getv(i - 1, j + 1, x, g_x, m, g_d7)
        d8 = g_transprob(j + 1, j, 1, deltavec, g_deltavec, m, g_d8)
        d3_v = d1 * p1(1)
        d8_v = d3 * p1(0)
        d13_v = d5 * p1(1)
        d18_v = d7 * p1(0)
        g_w(2) = d18_v * g_d8 + d8 * p1(0) * g_d7 + d13_v * g_d6 + d6 * 
     *p1(1) * g_d5 + d8_v * g_d4 + (d8 * d7 + d4 * d3) * g_p1(0) + d4 * 
     *p1(0) * g_d3 + d3_v * g_d2 + (d6 * d5 + d2 * d1) * g_p1(1) + d2 * 
     *p1(1) * g_d1
        w(2) = d3_v * d2 + d8_v * d4 + d13_v * d6 + d18_v * d8
C--------
C
      end
