% reads homotopy  export files for LBD/OF with No EE, saves as matlab files

%%% Automomous run setup - comment out if running from hom_start.m
	% fileMod='r89d6t00'; % run code, used in directory and file names
	% deltaRng=[0.06 0.0]; % starting and ending values of delta
	% rhoRng=[0.89 0.89]; % rho that comes with the run (if homotopy was on rho, should modify this file
	% XEnds=1; % 1=exlude start/end of run when computing number of equilibria 
 % (should be on for one of two runs that make up a loop
%%% End of Automomous run setup - comment out if running from hom_start.m

%%% unzip homotopy results into HomXpt if they were computed on different machine
%%% unix format, this is where this was done
%%% this code assumes results are already in HomXpt
% eval(['!unzip -jq ~/homZips/vOut100/h9_' fileMod '.zip -d HomXpt']);

M=30; 
p=zeros(M,M); 
V=zeros(M,M); 
filedone=0; 
deltas=[];rhos=[];sss=[];
step=1; %%% starting step of import %%%%%%%%%%%%%%%%%%% 
offV=0;
offP=M*M;
N=2*M*M;
disp(' ');

disp('reading homotopy output: step, Param, Delta')
% create directory to store homotopy steps in matlab format
mkdir(['HomDat/' fileMod]); 

while ~filedone
    % check if step file exists
    fileX=['HomXpt/' sprintf('hom_%05d.dat',step)];
    if exist(fileX, 'file')
        % read file        
		fid = fopen(fileX,'r'); % open file for write
		if fid==-1
                error('File open failed')
		end
        
        Y=fread(fid,N+2,'float64');       
        fclose(fid);
        % extract value and policy
        V = reshape( Y( (offV+1) : (offV+M*M) ), M, M); 
        p = reshape( Y( (offP+1) : (offP+M*M) ), M,M);
        % compute and record delta and rho
        delta2 = deltaRng(1) + Y(N+1)*( deltaRng(2) - deltaRng(1) );
        rho    =   rhoRng(1) + Y(N+1)*(   rhoRng(2) -   rhoRng(1) );
        deltas=[deltas; delta2];
        rhos=[rhos; rho];
        sss=[sss; Y(N+1)];
        
        if mod(step,20)==0
            disp(sprintf('step %4d, lmbd=%.4f, delta=%.4f', step, Y(N+1), delta2 ));
        end
        % save matlab file
        filename=sprintf('step_%05d.mat', step);
        save(['HomDat/' fileMod '/' filename], 'p','V','delta2','rho'); 
          % in matlab 7, can add ",'-v6'" to save as Matlab v6 file
    else
        filedone=1;
    end 
    step=step+1;
    
end

steps=step-2;
save(['HomRes/DeltaRho_' fileMod],'deltas','rhos','sss','steps','XEnds','rho')

% remove files after reading in
% this makes sense if you got files from zip
% this is in Unix format
% eval('!rm HomXpt/hom_0[0-4]*.dat')
% eval('!rm HomXpt/hom_*.dat')

disp(sprintf('%s: %d steps, min,max=[%.4f,%.4f]',fileMod,steps, min(deltas),max(deltas)))
