% Entry&Exit: Closed communicating classes and limiting distribution.
% duopoly, entry & exit
%

% Globals 
global M % max level of efficiency
global Pe % transition matix
global DL % Limiting distr., 
global Convd %warnings on results
global lMode lMean % mode and mean (expectation) of "firm-size" distribution

% Dimension of state space.
if (length(size(V))~=2) | (size(V,1)~=size(V,2))
	error('Error: Must have duopoly!'); 
end

if isempty(Pe)
    run TransMatEE_duo
end

disp('Calculating limiting distribution ...')
tic;

% Transition matrix.
% run TransMat_duo % assumed 2b run by calling 

% Closed communicating classes.
blocks = partition(Pe);
ccc=max(blocks);
%disp(sprintf( '# of CCC = %d', ccc ))
if ccc>1
    Convd=[Convd sprintf('  #CCC>1 (=%d)', ccc)]
    disp('   Multiple Closed communicating classes !!!')
end
    
% Limiting distribution.
%blocks = partition(P);
DL = repmat(NaN,M+1,M+1);
blocksm =DL;
% for m=1:max(blocks)
        %% main calc
    %ind = find(blocks==1);
    Q = Pe; %(ind,ind);
    Q = eye( size(Q) ) - Q;
	Q(:,1) = ones( size(Q,1), 1 );
    thisDL = [ 1 , zeros( 1, size(Q,1)-1 ) ]/Q;
      % convert into matrix format
   for n=1:length(thisDL)
	    j = rem(n,M+1); %rem(ind(n),M);
      	if j==0
         	i = n ./ (M+1); % ind(n) ./ M; 
            j = M+1;
       	else
          	i = (n-j) ./ (M+1) + 1; % (ind(n)-j) ./ M + 1;
    	end
        DL(i,j) = thisDL(n);
        blocksm(i,j) = blocks(n);
   end % for n
   %end % for m

   [lMean(1) lMean(2) lMode(1) lMode(2)] = meanmode(DL);
   if lMode(1)==M+1
       lMode(1)=lMode(2);
       lMode(2)=0;
   end

clear f fid fmt vec Q dv i j m n thisDL delta depr alt;

disp(sprintf('   ... Done (time elapsed - %f)',toc))