% markEE_LimDirect.m - calc limiting distr. directly, i.e. a0*P^limT
% duopoly, entry & exit
%

% Globals 
global M % max level of efficiency
global Pe % transition matix
global DL % Limiting distr., 
global Convd %warnings on results
global lMode lMean % mode and mean (expectation) of "firm-size" distribution
global limT
global i0 j0 

% Dimension of state space.
if (length(size(V))~=2) | (size(V,1)~=size(V,2))
	error('Error: Must have duopoly!'); 
end

if isempty(Pe)
    run TransMatEE_duo
end

if limT==0
    limT = 1000;
end
disp('Calculating limiting distribution DIRECTLY ...')
tic;

% Initial distribution (as vector)
a0 = zeros(1,(M+1).^2);
a0( (i0-1).*(M+1) + j0 ) = 1;

%thisDL = a0 * Pe ^ limT;
T2 = 1;
P_T = Pe;
while T2<limT
    P_T = P_T * P_T;
    T2 = T2 * 2;
    disp(sprintf(' T = %4d', T2))
end
thisDL = a0 * P_T;
limT = T2;

% Limiting distribution.
DL = repmat(NaN,M+1,M+1);
      % convert into matrix format
   for n=1:length(thisDL)
	    j = rem(n,M+1); %rem(ind(n),M);
      	if j==0
         	i = n ./ (M+1); % ind(n) ./ M; 
            j = M+1;
       	else
          	i = (n-j) ./ (M+1) + 1; % (ind(n)-j) ./ M + 1;
    	end
        DL(i,j) = thisDL(n);
   end % for n
   %end % for m

   [lMean(1) lMean(2) lMode(1) lMode(2)] = meanmode(DL);
   if lMode(1)==M+1
       lMode(1)=lMode(2);
       lMode(2)=0;
       if lMode(1) == M+1 % M+1,M+1
           lMode(1) = 0;
       end
   end

clear Q dv thisDL delta depr alt;

disp(sprintf('   ... Done (time elapsed - %f)',toc))