% Calc and Plot Transient distributions, entry and exit

% Globals 
global M mmax% max level of efficiency
global T DT 
global P Pe % transition matices
global i0 j0 maxT state0 

if isempty(Pe)
    run TransMatEE_duo
end

disp('Calculating transient distributions (Exit & Entry) ...'); 
tic;

% Initial distribution (as vector)
a0 = zeros(1,(M+1).^2);
a0( (i0-1).*(M+1) + j0 ) = 1;

% Prepare plots. - 4 plots per figure
K = length(T);

DT=zeros(M+1,M+1,K);
% Transient distribution.
for k=1:K
   
   % Calculate transient distribution.
   DT(:,:,k) = repmat(NaN,M+1,M+1); % init matrix
   thisa = a0 * Pe ^ T(k); % main calc
   
   % convert vector distr. into matrix
   for n=1:length(thisa)
        j = rem(n,M+1); % calc (i,j)(n)
   	    if j==0
      	    i = n./(M+1); j = M+1;
        else
      	    i = (n-j)./(M+1) + 1;
        end
        DT(i,j,k) = thisa(n);
   end % for n
   
end

disp(sprintf('   ... Done (time elapsed - %f), plotting',toc))


clear i j k h k n pos1 pos2 Ktilde a0 thisa plotno depr delta alt filestr fmt fid v vec subplotno ;

