% calculates mean and mode of firm-size distribution of states
% distribution a is in the MxM matrix
% returns [i-mean j-mean i-mode j-mode]

function [imn, jmn, imd, jmd] = meanmode(d)

MMM=size(d,2);
if MMM~=size(d,1)
    error('meanmode requires square matrix as argument')
end

lMode=[0 0]; lMean = [0 0];
maxD=0; nmaxD=0; % maximum probaility of state, and # of such states 
dfs=zeros(MMM); % firm-size distribution

for i=1:MMM
for j=1:i % i >= j
    dfs(i,j) = d(i,j);% + d(j,i)*sign(i-j);
    %lMean = lMean + [i j] * dfs(i,j); % ADD wWEIGHTING BY HALF OF MATRIX
    if dfs(i,j) > maxD % new maximum probability
        maxD=dfs(i,j); nmaxD=1;
        lMode = [i j];
    elseif dfs(i,j) == maxD % another state with max probability
        lMode = (lMode*nmaxD + [i j]) / (nmaxD+1);
        nmaxD = nmaxD+1;
    end
end
end

imn = NaN; jmn = NaN;
imd = lMode(1); jmd = lMode(2);


