% plotE_iter.m - iteration output for Exit only case
% 2 firms, EXIT, no entry

% global variables - see master file for comments

global M
global V p stay
global tolV tolp tols
global iter % note that iter was already increased by 1
global RunHead % title of run

global IterF
IterF=99;
figure(IterF);

% (top) left - p
h=subplot(2,2,1);
mesh([1:M], [0:M], [ p(1:M,M+1) p(1:M,1:M) ]');
set(h, 'YDir','reverse', 'XDir','reverse');
v = axis; v(1) = 1; v(2) = M; v(3) = 0; v(4) = M; 
v(5)=min(min( p(1:M,1:M) )); v(6)=max(max( p(1:M,:) )); axis(v); % axis: minx,maxx, miny, maxy
xlabel('i'); ylabel('j');
title( 'p(i,j)', 'FontSize',12, 'FontWeight','bold' );

% (top) right - V
h=subplot(2,2,2);
mesh([0:M], [0:M], [ V(M+1,M+1) V(M+1,1:M) ; V(1:M,M+1) V(1:M,1:M) ]');
v = axis; v(1) = 0; v(2) = M; v(3) = 0; v(4) = M; axis(v); % axis: minx,maxx, miny, maxy
xlabel('i'); ylabel('j');
title( 'V(i,j)', 'FontSize',12, 'FontWeight','bold' );
view( -75, 30);
    
%  bottom left - tolerance levels for NN last iterations
subplot(2,2,3);   
k = max(1,iter-25); % in case there areless than NN iterations
plot( [k:iter], [tolp(k:iter ) ; tolV(k:iter ) ; tols( k:iter )]);
v = axis; v(1) = k; v(2) = max(iter,2); v(3) = 0; axis(v);
xlabel('iterations');
legend('p','V','stay',0);
title('Tolerance', 'FontSize',12, 'FontWeight','bold' );

% bottom right - stay
subplot(2,2,4);  
mesh([0:M], [0:M], [ stay(M+1,M+1) stay(M+1,1:M) ; stay(1:M,M+1) stay(1:M,1:M)]');
v = axis; v(1) = 0; v(2) = M; v(3) = 0; v(4) = M; v(5)=min(v(5), 0.95); axis(v); % axis: minx,maxx, miny, maxy
xlabel('i'); ylabel('j');
title( 'Probability of Staying', 'FontSize',11, 'FontWeight','bold' );


subtitle(sprintf( '%s \n Iter# %d, tol(V)=%g, tol(x)=%g, tol(x)=%g)\n', ...
    RunHead, iter, tolV(iter), tolp(iter), tols(iter) ));
    
    
drawnow;
