% noEE: Results + Transients

% Globals 
global M mmax% max level of efficiency
global T2  
global PlotHead PlotHead2 PlotDate PlotPage% titles of plot
global P Pe % transition matices
global i0 j0 maxT state0 
global DL limT

% if length(T2)~=2
%     disp('Re-setting time periods (T2) p-V-Trans(2) plot: T2 is not a 2-vector');
%     T2 = [8 32];
% end
K=2;

f=figure('Name','Res+Trans', 'NumberTitle','off'); % title window, no "Figure N #:"

if ~isempty(DT) % transients already computed
    DT2=DT;
	z=find(DT2<1e-4);
	DT2(z)=NaN;
	
	for k=1:K
       
       h = subplot(2,3,k+3); 
	
       [tMean(1) tMean(2) tMode(1) tMode(2)] = meanmode(DT2(:,:,k));
       ModalProb = DT2(tMode(1),tMode(2),k);
       if tMode(1)==M+1
           tMode(1)=tMode(2);
           tMode(2)=0;
       end
       
       lin = stem3( repmat([1:M]',1,M), repmat([1:M],M,1), DT2(1:M,1:M,k) );
       set(lin, 'MarkerSize', 3, 'MarkerFaceColor', 'w');%, 'LineWidth', 1
       v = axis; v(1) = 1; v(2) = M; v(3) = 1; v(4) = M; v(5) = 0; axis(v);
       set(h,'XTick',[1 3:3:M]); set(h,'YTick',[1 5:5:M]); set(h,'YDir','normal'); 
       xlabel('e_{1}'); ylabel('e_{2}');  zlabel('Prob.');
       
       title(sprintf( 'T=%d: Mode=(%d,%d), Pr=%.3f', ...
                      T(k), tMode(1), tMode(2), ModalProb ))
	
       view(-15,30);
       
	end
end % if <transients computed> else

% drop near-zero values so that their markers do not clog the chart

%%% p(i,j)
%     zmin = min(min( p(1:M,1:M+1) )); pview = [-50,50]; 
%     zmax = round( max(max( p(1:M,1:M+1) ))  + 0.51);
    zmin = 0; zmax = 11; pview = [-50,40]; 
h=subplot(2,3,1);
mesh([1:M], [1:M], p(1:M,1:M)');
v = axis; v(1) = 1; v(2) = M; v(3) = 1; v(4) = M; v(5)=zmin; v(6)=zmax; axis(v); % 
xlabel('e_{1}'); ylabel('e_{2}'); 
set(h, 'YDir','reverse', 'XDir','reverse');
 hold on; %% cost function + value marker
 lin=plot3([1:M],repmat(M,1,M),cost(1:M)); set(lin,'LineWidth',1.5)
 lin=plot3([30 30],[30 30],[zmin p(30,30)],':k'); %set(lin,'LineStyle',':')
title( 'Price p(e) + cost(e1)' );%, 'FontSize',11
view( pview); % -55, 40 - view from (0,0)

%%% p(i,j) - 180 view
    zmin = min(min( p(1:M,1:M) )); pview = [-50,40]; 
    zmax = ceil( max(max( p(1:M,1:M) )) );
%     zmin = 0; zmax = 11; pview = [-50,50]; % 
h=subplot(2,3,2);
mesh([1:M], [1:M], p(1:M,1:M)');
v = axis; v(1) = 1; v(2) = M; v(3) = 1; v(4) = M; v(5)=zmin; v(6)=zmax; axis(v); % 
xlabel('e_{1}'); ylabel('e_{2}'); 
title( 'Price p(e) - 180 view' );%, 'FontSize',11
view( pview); % -55, 40 - view from (0,0)

% bottom left - V(i,j)
subplot(2,3,3);
mesh([1:M], [1:M], V(1:M,1:M)');
v = axis; v(1) = 1; v(2) = M; v(3) = 1; v(4) = M; axis(v); % axis: minx,maxx, miny, maxy
xlabel('e_{1}'); ylabel('e_{2}');
title( 'Value V(e)'); %, 'FontSize',11
view( -75, 30);

% Limiting distr
h = subplot(2,3,6);
if ~isempty(DL)
	tDL=DL; z=find(tDL<0.00001); tDL(z)=NaN;
	[tMean(1) tMean(2) tMode(1) tMode(2)] = meanmode(DL);
	ModalProb = DL(tMode(1),tMode(2));
	if tMode(1)==M+1
       tMode(1)=lMode(2);
       tMode(2)=0;
	end
   

	lin = stem3( repmat([1:M]',1,M), repmat([1:M],M,1), tDL(1:M,1:M) );
	set(lin, 'MarkerSize', 3, 'MarkerFaceColor', 'w'); % , 'LineWidth', 1
	v = axis; v(1) = 1; v(2) = M; v(3) = 1; v(4) = M; v(5) = 0; v(6) = min(v(6),1.001); axis(v);
    set(h,'XTick',[1 3:3:M]); set(h,'YTick',[1 5:5:M]); set(h,'YDir','normal'); 
	xlabel('e_{1}'); ylabel('e_{2}'); zlabel('Prob.');
	view(-15,30);
	% check how the limiting distr. was calculated
	if limT > 0 % direct calculation
        stitle = sprintf('(T=%d, start at %s)', limT, state0);
	else % ergodic, according to formulas
        stitle = 'T=Inf';
	end
   stitle = [stitle sprintf( ': Mode=(%d,%d), Pr=%.3f', ...
                  tMode(1), tMode(2), ModalProb ) ];

    if sum(sum( DL(1:M,1:M) )) < ( 1 - eps*100)
        stitle=[stitle ' Inactive states w/ Pr>0 !!!']
    end
	title(stitle );%, 'FontSize',11
else
    title('Limiting distribution not calculated'); %, 'FontSize',11
end


%%% finalize
if min(min(stay)) > 1 - 1e-4
    sStay='';
else
    sStay=' ***** OPER.PROB < 1 !!!! *****';
end

subtitle(sprintf( '%s: RESULTS + TRANSIENTs (start at %s)%s\n%s \n', ... 
            PlotHead2, state0, sStay, PlotHead )); 

% footer information  
s2='';
if ~isempty(lHerfP)
    s2=[s2 sprintf('Limiting Herf.=%.4f   ', lHerfP)];
end
if ~isempty(maxHerfP)
    s2=[s2 sprintf('Max.Herf.=%4.3f, achieved at T =  %d', maxHerfP, amaxHerfP)];
end
% 	s2 = sprintf(['SURPLUS: Cons.=%4.3f, Total=%4.3f; ' ...
%               'DISC-d (1st %d yrs): consumer=%4.1f, total=%4.1f;  ' ...
%               'MODE=(%d,%d); Max(dp)=%3.2f' ...
%               '\nHERFS: Uncond. mkt. share=%4.3f, Cond. mkt. share=%4.3f ' ...
%               '(Max=%4.3f, @T=%d), Value=%4.3f' ], ...
%               lWelfare, lSurplus, lDyears, lWelfareD, lSurplusD, ...
%               round(lMode(1)), round(lMode(2)), maxdP, ...
%               lHerfP0, lHerfP, maxHerfP, amaxHerfP, lHerfV);
ffooter(s2);

if PlotPage>0
    fpage(sprintf( '%s\npage %d', PlotDate, PlotPage ));
    PlotPage = PlotPage + 1; 
else
    fpage(PlotDate);
end
orient landscape; 
drawnow;

global psFile
if size(psFile,2)>0
      print('-dpsc2',psFile,'-append');
end

clear i j k h k n pos1 pos2 Ktilde a0 thisa plotno depr delta alt filestr fmt fid v vec subplotno ;

