% Contional transition probability 
% i, old_i - 1:M, outcome = win/loose
% uses delta(eff) subfunction (below)


function p = transLC(i, old_i, outcome)

% global variables - see master file for comments
global delta1 delta2 lambda % efficiency depreciation
global win loose % conditioning events (outcomes of sale)
global M % max level of efficiency

%%% fool-proof arguments
% if i ~= round(i)  
%     error('1st argument of transLC should be integer')
% end
% 
% if (old_i ~= round(old_i)) | (old_i ~= min(max(old_i,1),M))
%     error('2nd argument of transLC should be integer 1:M')
% end
% 
% if outcome ~= win & outcome ~= loose
%     error('3d argument of transLC should be win(1) or loose(0) !')
% end

% pre-calculate depreciation probability
di = delta(old_i);

% main calculation
if outcome == win
    if old_i < M 
        
        if i == old_i + 1
            p = 1 - di;
        elseif i == old_i
            p = di;
        else
            p = 0;
        end
        
    else % i.e. old_i==M
        
        if i == old_i
            p = 1;
        else
            p = 0;        
        end
        
    end % if i<=M
    
else % i.e. outcome == loose
    if old_i > 1 
        
        if i == old_i
            p = 1 - di;
        elseif i == old_i - 1
            p = di;
        else
            p = 0;
        end
        
    else % i.e. i==1
        
        if i == old_i
            p = 1;
        else
            p = 0;        
        end
        
    end % if i<=M
    
end % if outcome == win/loose
    

%%%% Depreciation probability delta(efficiency)
function d=delta(eff)
    global delta1 delta2 lambda % efficiency depreciation
    d = lambda.*delta1 + (1-lambda).*(1 - (1-delta2).^eff);
